<%@ page import="org.apache.commons.fileupload.*, java.util.List, java.io.File, java.util.Iterator" %>
<%
  // first check if the request is multipart
  // if not indicate so to the end user
  if(!FileUpload.isMultipartContent(request)){

  	request.setAttribute("message", "Request is not multipart!");
		request.getRequestDispatcher("msg.jsp").forward(request, response);
		return;
  }

  // now create an instance of DiskFileUpload
  DiskFileUpload fileUpload = new DiskFileUpload();

  // The DiskFileUpload will parse the incoming
  // request for uploaded files.
  List items = fileUpload.parseRequest(request);

  // iterate over this list to gather the form elements
	Iterator itr = items.iterator();
	FileItem item;

	while(itr.hasNext()){

		item = (FileItem) itr.next();

		// check if the current item is a form field or an uploaded file
		if(item.isFormField()){

			// get the name of the field
			String fieldName = item.getFieldName();

			// if it is name, set it in request to thank the user
			if(fieldName.equals("username"))
				request.setAttribute("message", "Thank You " + item.getString());

		} else {

			// the item is an uploaded file
			// save it to disk after checking that there is something to be saved
			if(item.getSize() > 0){
					File fullFile = new File(item.getName());
					File savedFile = new File(getServletContext().getRealPath("/"), fullFile.getName());
					item.write(savedFile);
			}
		}
	}

	// finally send to the msg page
	request.getRequestDispatcher("msg.jsp").forward(request, response);

%>