<%@ page import="org.apache.commons.fileupload.*, java.util.List, java.io.File, java.util.Iterator, java.util.Vector" %>
<%
  // first check if the request is multipart
  // if not indicate so to the end user
  if(!FileUpload.isMultipartContent(request)){

  	request.setAttribute("message", "Request is not multipart!");
		request.getRequestDispatcher("msg.jsp").forward(request, response);
		return;
  }

  // now create an instance of FileUpload
  FileUpload fileUpload = new FileUpload();

  // assign a DefaultFileItemFactory to this FileUpload
  fileUpload.setFileItemFactory(new DefaultFileItemFactory());

  // The FileUpload will parse the incoming
  // request for uploaded files.
  List items = fileUpload.parseRequest(request);

  // iterate over this list to gather the form elements
	Iterator itr = items.iterator();
	FileItem item;

	// variables to hold the data
	String name = "Not answered";
	String team = "Not answered";
	String imageFileName = "None submitted";
	String wordFileName  = "None submitted";

	String imageFileMessage = "";
	String wordFileMessage  = "";

	StringBuffer software = new StringBuffer();
	StringBuffer books    = new StringBuffer();

	while(itr.hasNext()){

		item = (FileItem) itr.next();

		// get the field name, as this will be our criteria for processing
		String fieldName  = item.getFieldName();

		// based on what item we have, processing will be different
		if(item.isFormField()){

			// processing a normal form field
			String fieldValue = item.getString();

			if(fieldName.equals("software")){
				software.append(fieldValue + " ");
			}else if(fieldName.equals("books")){
				books.append(fieldValue + " ");
			}else if(fieldName.equals("username")){
				name = fieldValue;
			}else if(fieldName.equals("team")){
				team = fieldValue;
			}
		} else {

			// processing a file upload

			// check if a file was uploaded
			if(item.getSize() <= 0)
				continue;

			// use the content type to find if the user uploaded the right file
			String contentType = item.getContentType();
			File uploadedFile  = new File(item.getName());

			if(fieldName.equals("imagefile")){

				// check its content type
				if(!contentType.startsWith("image")){
					imageFileMessage = "Incorrect file uploaded! File is not of type image.";
				}

				imageFileName = uploadedFile.getName();
			} else {

				// must be the word file
				if(contentType.indexOf("msword") == -1){
					wordFileMessage = "Inccorect File uploaded! File is not of type Word.";
				}

				wordFileName = uploadedFile.getName();
			}
		}
	}

	// construct the message for the next page
	StringBuffer buffer = new StringBuffer("Thank You! The result of your submission is shown below:<br/>");
	buffer.append("Your Name: " + name + "<br/>");
	buffer.append("Your Image file: " + imageFileName + ". " + imageFileMessage + "<br/>");
	buffer.append("Your Word file: "  + wordFileName + ". " + wordFileMessage + "<br/>");
	buffer.append("Software used: " + software + "<br/>");
	buffer.append("Favourite team: " + team + "<br/>");
	buffer.append("Books read: " + books + "<br/>");

	request.setAttribute("message", buffer.toString());

	// finally send to the msg page
	request.getRequestDispatcher("msg.jsp").forward(request, response);

%>