<%@page import="javax.sql.DataSource, javax.naming.*, java.sql.*, 
                org.apache.commons.fileupload.*, java.util.List, 
                java.io.File, java.util.Iterator" %>
<%
  // look up the context
  Context ctx = new InitialContext();
  if(ctx == null ) 
     throw new Exception("No Initial Context was found!");

  // from this context grab the datasource we have defined in the server.xml/web.xml
  DataSource ds = 
    (DataSource)ctx.lookup(
      "java:comp/env/jdbc/commons");

  if (ds != null) {
    // from the datasource, get a connection, this will be a connection from the pool
    Connection conn = ds.getConnection();

    if(conn != null)  {
      // the statement that we will use to write the content of uploaded files to database
      PreparedStatement stmt = 
        conn.prepareStatement(
          " INSERT INTO chapter2_fileupload " +
          " (datecreated, createdby, fieldname, filename, file) " +
          " VALUES (now(), ?, ?, ?, ?)");

      // parse the incoming request
      DiskFileUpload fileUpload = new DiskFileUpload();
      List items = fileUpload.parseRequest(request);

      Iterator itr = items.iterator();
      FileItem item;
      String   userName = "";

      while(itr.hasNext()){						

        item = (FileItem) itr.next();

        // check if the current item is a form field or an uploaded file
        if(item.isFormField()){
          // must be the username field
          userName = item.getString();
        } else {
          if(item.getSize() > 0){
            stmt.clearParameters();
            stmt.setString(1, userName.length() == 0 ? "RemoteUser" : userName);
            stmt.setString(2, item.getFieldName());
            stmt.setString(3, item.getName());
            stmt.setBytes(4, item.get());
            stmt.addBatch();
          }
        }
      }

      // since there might be multiple uploaded files, they are executed in a batch
      stmt.executeBatch();

      if(stmt != null) stmt.close();					
    }

    if(conn != null) conn.close();
  }
%>