<%@ page import= "java.util.*, java.io.FileInputStream, org.apache.commons.validator.*, org.apache.commons.validator.util.*, com.manning.commons.chapter06.WebJavaBeanV1" %>
<%
  // gather all the data from the request, and set it in a JavaBean
  String required = request.getParameter("requiredField");
  String numeric  = request.getParameter("numericField");
  String date     = request.getParameter("dateField");
  String range    = request.getParameter("rangeField");
  String email    = request.getParameter("emailField");
  String url      = request.getParameter("urlField");
  String regExp   = request.getParameter("regExpField");
  String cc       = request.getParameter("ccField");
  String isbn     = request.getParameter("isbnField");
  String multi    = request.getParameter("multiField");
  
  // create a new JavaBean
  WebJavaBeanV1 bean = new WebJavaBeanV1();
  bean.setRequired(required);
  bean.setNumeric(numeric);
  bean.setDate(date);
  bean.setRange(range);
  bean.setEmail(email);
  bean.setUrl(url);
  bean.setRegExp(regExp);
  bean.setCc(cc);
  bean.setIsbn(isbn);
  bean.setMulti(multi);
 
  // now create the Validator
  ValidatorResources resources = 
    new ValidatorResources(
      getClass().getResourceAsStream("/validatorweb.xml"));
    
  Validator validator = new Validator(resources, "webform");
  
  validator.setParameter(Validator.BEAN_PARAM, bean);
  
  // and validate
  ValidatorResults results = validator.validate();
  
  List fieldList = 
    resources.getForm(Locale.getDefault(), "webform").getFields();
  
  Iterator itr = fieldList.iterator();
  
  while(itr.hasNext()) {
    Field field = (Field)itr.next();
    ValidatorResult result = results.getValidatorResult(field.getKey());
    String depends = field.getDepends(); // returns a comma separated list of validators
    StringTokenizer dependsTokens = new StringTokenizer(depends, ",");
    int countDepends = dependsTokens.countTokens();
    for(int i = 0; i < countDepends ; i++) {
      String token = dependsTokens.nextToken().trim();
      request.setAttribute(
        field.getKey(), 
        result.isValid(token) ? "Yes" : "No");
    }
  }
  
  request.setAttribute("bean", bean);
  request.getRequestDispatcher("validatorform.jsp").forward(
    request, 
    response);
%>